PCL     	EQU     	2H
STATUS	EQU	3H
PORT_A	EQU	5H
TRISA	EQU	5H
PORT_B  	EQU     	6H
TRISB   	EQU     	6H
PCLATH  	EQU     	0AH
CNT_REG	EQU	0CH
TEMP	EQU	10H
SW	EQU	4  	;SWITCH CONNECTED TO BIT 0, PORT A
C         EQU       0
Z	EQU	2

	ORG     	0
START   	BSF     	STATUS,5 	;SET TO PAGE 1
          MOVLW     011000B   ;
          MOVWF     TRISA     ;DEFINE PORT_A BIT 4,5 INPUT
	CLRF    	TRISB     ;DEFINE PORT_B ALL OUTPUT
	BCF     	STATUS,5  ;BACK TO PAGE 0
MAIN_LOOP MOVLW     04H       ;LOAD INITIAL VALUE
	MOVWF	CNT_REG	;CLEAR COUNTER REGISTER
DISPLAY	MOVF    	CNT_REG,W ;LOAD WORK'G REG WITH DESERVE NUMBER
	ANDLW   	0FH       ;GIVE UP BIT 4-7, KEEP 0-3
	CALL	CONVERT	;CONVERT TO RELATIVE OUTPUT
	MOVWF	TEMP
	MOVWF   	PORT_B    ;RB0 ON
	DECF      CNT_REG,F	;OKAY, DECREMENT COUNTER REG.
          MOVF      CNT_REG,W ;TRANSFER COUNTER-1 TO PORT_A
          MOVWF     PORT_A    ;OUTPUT TO SOLENOID
          CALL      DELAY
          MOVF      CNT_REG,F ;TEST IF ZERO
          BTFSS     STATUS,Z
	GOTO    	DISPLAY
          GOTO      MAIN_LOOP
CONVERT 	ADDWF     PCL,1     ;PCL = FW
	retlw     03FH	;0
	retlw     006H	;1
	retlw     05BH	;2
	retlw     04FH	;3
	retlw     066H	;4
	retlw     06DH	;5
	retlw     07DH	;6
	retlw     007H	;7
	retlw     07FH	;8
	retlw     06FH	;9
	retlw     077H	;A
	retlw     07CH	;B
	retlw     039H	;C
	retlw     05EH	;D
	retlw     079H	;E
	retlw     071H	;F
DLY20MS
	MOVLW    	 50       ;LOAD WORK'G REG. WITH VALUE 255
	MOVWF   	0DH       ;TRANSFER WORK'G REG. TO RAM f0D
DLY1	MOVLW   	255       ;LOAD WORK'G REG. WITH VALUE 255
	MOVWF   	0EH       ;TRANSFER WORK'G REG. TO RAM f0D
DLY2	DECFSZ  	0EH,F     ;[f0E] - 1 = 0 ?
	GOTO    	DLY2      ;NO, GO BACK TO DLY2 UNTIL 0 COUNT
	DECFSZ  	0DH,F     ;[f0D] - 1 = 0 ?
	GOTO    	DLY1      ;NO, GO BACK TO DLY1 UNTIL 0 COUNT
	RETURN              ;RETURN TO MAIN PROGRAM
;***********************************************************
DELAY
	MOVLW	010H
	MOVWF	0DH
DLYL1	movlw     0FFh
	movwf     0Eh
DLYL2     movlw     0FFh
	movwf     0Fh
DLYL3     decfsz    0FH
	goto      DLYL3
	decfsz    0Eh
	goto      DLYL2
	decfsz    0Dh
	goto      DLYL1
	return
	END
