PCL     	EQU     	2H
STATUS	EQU	3H
PORT_A	EQU	5H
TRISA	EQU	5H
PORT_B  	EQU     	6H
TRISB   	EQU     	6H
PCLATH  	EQU     	0AH
CNT_REG	EQU	0CH
TEMP	EQU	10H
CMDFLAG   EQU       11H
SW_A	EQU	3  	;SWITCH CONNECTED TO BIT 3, PORT A
SW_B      EQU       4
C         EQU       0
Z	EQU	2
W         EQU       0
F         EQU       1

	ORG     	0
START   	BSF     	STATUS,5 	;SET TO PAGE 1
          MOVLW     011000B   ;
          MOVWF     TRISA     ;DEFINE PORT_A BIT 4,5 INPUT
	CLRF    	TRISB     ;DEFINE PORT_B ALL OUTPUT
	BCF       STATUS,5  ;BACK TO PAGE 0
          BCF       CMDFLAG,0

MAIN_LOOP MOVLW     04H       ;LOAD INITIAL VALUE
	MOVWF	CNT_REG
DISPLAY	MOVF    	CNT_REG,W ;LOAD WORK'G REG WITH DESERVE NUMBER
         	MOVWF	TEMP      ;KEEP VALUE IN TEMP
	CALL	CONVERT	;CONVERT TO RELATIVE OUTPUT
	MOVWF   	PORT_B    ;RB0 ON
	DECF      TEMP,F	;OKAY, DECREMENT COUNTER REG.
          MOVF      TEMP,W    ;TRANSFER COUNTER-1 TO PORT_A
          MOVWF     PORT_A    ;OUTPUT TO SOLENOID
          BTFSS     CMDFLAG,0 ;SKIP IF SW_A PRESSED
          CALL      DELAY
          CALL      DELAY
          BTFSS     CMDFLAG,0 ;SKIP IF SW_A PRESSED
	DECF      CNT_REG,F	;OKAY, DECREMENT COUNTER REG.

CHK_A     BTFSC     PORT_A,SW_A         ;DETECT A SWITCH
	GOTO      CHK_B               ;NO KEY DEPRESS SKIP
	CALL      DLY20MS             ;KEY PRESS, DEBOUNCE
WAIT_1    BTFSS     PORT_A,SW_A         ;WAIT FOR KEY RELEASE
	GOTO      WAIT_1              ;TILL NOT RELEASE
          BSF       CMDFLAG,0
	DECF      CNT_REG,F	          ;DECREMENT COUNTER REG.

CHK_B     BTFSC     PORT_A,SW_B         ;CHECK IF B DEPRESS
          GOTO      NO_BPRESS
	CALL      DLY20MS             ;KEY PRESS, DEBOUNCE
WAIT_2    BTFSS     PORT_A,SW_B         ;WAIT FOR KEY RELEASE
	GOTO      WAIT_2              ;TILL NOT RELEASE
          BCF       CMDFLAG,0           ;RESET FLAG

NO_BPRESS MOVF      CNT_REG,F ;TEST IF ZERO
          BTFSS     STATUS,Z
          GOTO    	DISPLAY
          GOTO      MAIN_LOOP

CONVERT 	ADDWF     PCL,1     ;PCL = FW
	retlw     03FH	;0
	retlw     006H	;1
	retlw     05BH	;2
	retlw     04FH	;3
	retlw     066H	;4
	retlw     06DH	;5
	retlw     07DH	;6
	retlw     007H	;7
	retlw     07FH	;8
	retlw     06FH	;9

DLY20MS
	MOVLW    	0FFH       ;LOAD WORK'G REG. WITH VALUE 255
	MOVWF   	0DH       ;TRANSFER WORK'G REG. TO RAM f0D
DLY11	MOVLW   	255       ;LOAD WORK'G REG. WITH VALUE 255
	MOVWF   	0EH       ;TRANSFER WORK'G REG. TO RAM f0D
DLY22	DECFSZ  	0EH,F     ;[f0E] - 1 = 0 ?
	GOTO    	DLY22     ;NO, GO BACK TO DLY2 UNTIL 0 COUNT
	DECFSZ  	0DH,F     ;[f0D] - 1 = 0 ?
	GOTO    	DLY11     ;NO, GO BACK TO DLY1 UNTIL 0 COUNT
	RETURN              ;RETURN TO MAIN PROGRAM
;***********************************************************
DELAY
	MOVLW	05
	MOVWF	0DH
DLYL1	movlw     0FFh
	movwf     0Eh
DLYL2     movlw     0FFh
	movwf     0Fh
DLYL3     decfsz    0FH,F
	goto      DLYL3
	decfsz    0Eh,F
	goto      DLYL2
	decfsz    0Dh,F
	goto      DLYL1
	return
	END
