#include <stdio.h>
#include <dos.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

#define  data_latch 0x0378
#define print_status 0x0379
#define ctl_latch 0x037A

#define load_config     0
#define load_program    2
#define load_data       3
#define read_program    4
#define read_data       5
#define increment_adr   6
#define begin_program   8

FILE *hex_file;
char filename[20];
int config_byte[8];
int main_program[1024];
int bytes,address,code,col,tmp,i;
char data_in[43];

void print_ic(int x,int y)
	{
	gotoxy(x+3,y++);    printf("PIC16C84 DEVELOPMENT PROGRAMMER");
	y++;
	gotoxy(x,y++);  printf("RA1 RA0 OS1 OS2 VDD RB7 RB6 RB5 RB4");
	gotoxy(x,y++);  printf("п");
	gotoxy(x,y++);  printf("      PIC 16C84                  ");
	gotoxy(x,y++);  printf("         04/P                    ");
	gotoxy(x,y++);  printf(" o    9436 CBA                   ");
	gotoxy(x,y++);  printf("");
	gotoxy(x,y++);  printf("RA2 RA3 RA4 RST VSS RB0 RB1 RB2 RB3");
	}

void print_config(int config_in)
	{

	  gotoxy(5, 12);
		printf("The configuration setup are:");

	  gotoxy(5,13); tmp = config_in;
		if ((config_in & 0x10) == 0)
			printf("Code protection on");
		    else
			printf("Code protection off");

	  gotoxy(5,14); config_in = tmp;
		if ((config_in & 0x08) == 0)
			printf("Power-up timer disabled");
		    else
			printf("Power-up timer enabled");

	  gotoxy(5,15); config_in = tmp;
		if ((config_in & 0x04) == 0)
			printf("Watch-dog timer disabled");
		    else
			printf("Watch-dog timer enabled");

	  gotoxy(5,16); config_in = 0x03 & tmp;
		if (config_in == 3)
		    printf("Oscillator: RC");
		if (config_in == 2)
		    printf("Oscillator: HS");
		if (config_in == 1)
		    printf("Oscillator: XT");
		if (config_in == 0)
		    printf("Oscillator: LP");
	}

void instruct(unsigned char n)
     {
     for (i = 1; i <= 6; i++)
	 {
	 tmp = n;
	 if ((tmp & 0x01) == 1)
	      {
	      outp(data_latch,3);
	      outp(data_latch,1);
	      }
	   else
	      {
	      outp(data_latch,2);
	      outp(data_latch,0);
	      }
	 n >>= 1;
	 }
     }

void serial_out(int n)
     {
     outp(data_latch,2);
     outp(data_latch,0);

     for (i = 1; i <= 14; i++)
	 {
	 tmp = n;
	 if ((tmp & 0x0001) == 1)
	      {
	      outp(data_latch,3);
	      outp(data_latch,1);
	      }
	   else
	      {
	      outp(data_latch,2);
	      outp(data_latch,0);
	      }
	 n >>= 1;
	 }
     outp(data_latch,2);
     outp(data_latch,0);
     }

int serial_in()
     {
     unsigned int n = 0;

     outp(data_latch,2);
     outp(data_latch,0);

     for (i = 1; i <= 14; i++)
	 {
	      outp(data_latch,3);
	      outp(data_latch,3);
	      tmp = inp(print_status);
	      if ((tmp & 0x20) == 0x20) (n += 0x8000);
	      outp(data_latch,0);
	      n >>= 1;
	 }
     n >>= 1;
     outp(data_latch,2);
     outp(data_latch,0);
     return(n);
     }

void atoh(void)
	{
	tmp = data_in[col];
	tmp -= 48;
	if (tmp > 9)
	(tmp -= 7);
	}

int getbyte(void)
      {
	int byte;
	atoh();
	byte = (0xf0 & (tmp <<= 4));
	col++;
	atoh();
	byte += (0x0f & tmp);
	col++;
	return (byte);
      }

int getword(void)
      {
	int word;

	atoh();
	word = (0xf000 & (tmp <<= 12));
	col++;
	atoh();
	word += (0x0f00 & (tmp <<= 8));
	col++;
	atoh();
	word += (0x00f0 & (tmp <<= 4));
	col++;
	atoh();
	word += 0x000f & tmp;
	col++;
	return (word);
      }

int get_file()
      {
      char reply;
      do
	{
		gotoxy(10,18);  clreol();
		gotoxy(10,18);  printf("Enter object HEX file :");
		gets(filename);
		tmp = strlen(filename);
		if (tmp == 0)
			return (1);
		gotoxy(10,18);
		printf("Object HEX file is %s y/CR",filename);
		reply = toupper(getch());
	} while (reply == '\N');
     return (0);
     }

int read_hex_file(void)
	{
	int len = 60;

	hex_file = fopen(filename,"r+b");
	if (!hex_file)
		{
		gotoxy(10,18); clreol();
		printf("cannot find %s \a",filename);
		gotoxy(15,19);
		printf("Hit ENTER ");
		getch();
		return(1);
		}

      // make blank area 0x3FFF
      for (i = 0; i <= 1024; i++)
	     (main_program[i] = 0x3FFF);
      do
	{
	fgets(data_in,len,hex_file);
	col = 1;
		bytes = getbyte();
		address = getword();
		code = getbyte();
	for (i = 0; i <= (bytes-1); i++)
		{
		main_program[address] = getword();
		address++;
		}
	}while (code == 0);
	fclose(hex_file);
	return (0);
	}

void program_main_prog(void)
	{
	int c,t;

	gotoxy(50,8); printf("Programming main memory...");
	for (c = 0; c <= 1023; c++)
		{
		gotoxy(50,9); printf("address :%04X",c);
		t = main_program[c];

		instruct(read_program);
		tmp = serial_in();
		if (t != tmp)
			{
			instruct(load_program);
			serial_out(t);
			instruct(begin_program);
			delay(10);
			}
		instruct(increment_adr);
		}
	}

int verify_program(void)
	{
	int t,c;
	gotoxy(50,10);	printf("Verifying main memory...");
	for (c = 0; c <= 1023; c++)
		{
		gotoxy(50,11); printf("address :%04X",c);
		instruct(read_program);
		t = serial_in();
		if (t != main_program[c])
		       {
		       gotoxy(50,14); printf("Error in %04X \a",c);
		       gotoxy(5,20);
		       return (1);
		       }
		instruct(increment_adr);
		}
	  gotoxy(64,11);      printf("OK!");
	return (0);
	}

void mclr_reset(void)
	{
	outp(data_latch,0);
	delay(1);
	outp(ctl_latch,0);
	delay(1000);
	}

void release(void)
	{
	outp(ctl_latch,0xff);
	}

int program_configuration(void)
     {
	int c,t;

	instruct(load_config);
	serial_out(0x03ff);
	instruct(increment_adr);
	instruct(increment_adr);
	instruct(increment_adr);
	instruct(increment_adr);
	instruct(increment_adr);
	instruct(increment_adr);
	instruct(increment_adr);

		instruct(read_program);
		t = 0x1f & serial_in();
	if (t != config_byte[7])
	    {
		gotoxy(50,12); printf("Programming config byte...");
		t = 0x1f & config_byte[7];
		instruct(load_program);
		serial_out(t);
		instruct(begin_program);
		delay(500);
		gotoxy(50,13);	printf("Verifying config byte...");
		instruct(read_program);
		tmp = 0x1f & serial_in();
		if (tmp != t)
		       {
		       gotoxy(50,15); printf("Configuration error \a");
		       gotoxy(5,20);
		       return (1);
		       }
		gotoxy(50,14);	printf("Verify okey");
		gotoxy(5,20);
		delay(1000);
	   }
	   else
		{
		gotoxy(50,15);
		printf("configuration no change!");
		}
      return (0);
      }

int main(int argc, char *argv[])
	{
	int config, error_status;
	char s;

	if (argc > 1)
		strcpy(filename,argv[1]);
	if (argc == 3)
		{
		strcpy(data_in,argv[2]);
		col = 0;
		config = getbyte();
		if (config > 0x1f)
		     {
		     printf("parameter error !! \a");
		     return (0);
		     }
		}
	 if (argc <= 2)
		config = 0x19;

	config_byte[7] = config;
	release();
	clrscr();
	print_ic(5,2);
	print_config(config);
	if (argc == 1)
	error_status = get_file();
	     if (error_status == 1)
		   return (1);
		error_status = read_hex_file();
		if (error_status == 0)
		     {
		     mclr_reset();
		     program_main_prog();
		     error_status = verify_program();
			if (error_status == 0)
			    {
			     delay(1000);
			     program_configuration();
			    }
		     }
	release();
	return (0);
        }
