IND	EQU	00
RTCC	EQU	01
OPTIONf	EQU	01
PCL	EQU	02
STATUS	EQU	03
FSR	EQU	04
PORTA	EQU	5H
TRISA	EQU	5H
PORTB	EQU	6H
TRISB	EQU	6H
INTCON	EQU	0BH
CNTREG	EQU	10H	;[ƼȦs(Τۭq)
TEMP	EQU	11H
BITCNT	EQU	12H	;ΤȦs
BYTCNT	EQU	13H
SCANCDE	EQU	14H
H_BYTE	EQU	15H
L_BYTE	EQU	16H
R0      	EQU	17H
R1	EQU	18H
R2	EQU	19H
LPCNT	EQU	1AH
BUFFER	EQU	20H
CLK	EQU	0	;74LS164 8} CLOCK
DAT	EQU	1	;74LS164 1,2} DATA IN
C	EQU	0
Z	EQU	2
W	EQU	0
F	EQU	1
SW	EQU	4
	ORG	0
	GOTO	START
;-------------------------------------------------------
	ORG	4
DISPLAY	BCF	INTCON,2
	CLRF	RTCC
	MOVLW	00000001B
	MOVWF	SCANCDE
	MOVLW	4
	MOVWF	BYTCNT
	MOVLW	BUFFER
	MOVWF	FSR
BYT4OUT	
	MOVF	IND,W
	MOVWF	TEMP
	COMF	TEMP,F
	MOVLW	00000000B
	MOVWF	PORTA
	CALL	SERLOUT
	MOVF	SCANCDE,W
	MOVWF	PORTA
	MOVLW	05H	;DELAY 4MS
	CALL	DELAY
	BCF	STATUS,C
	RLF	SCANCDE,F
	INCF	FSR,F
	DECFSZ	BYTCNT,F
	GOTO	BYT4OUT
	RETFIE
;------------------------------------------------------			
START	BSF	STATUS,5	;mhɭ1
	CLRF	TRISA
	MOVLW	00000100B
	CLRF	TRISB
	MOVLW	00000101B	;PRESCALAR SETTING 1:32
	MOVWF	OPTIONf	;RTCC INTERNAL CKS
	BCF	STATUS,5	;m^ɭ0
	MOVLW	10100000B	;ENABLE RTCC INTERRUPT
	MOVWF	INTCON
	CLRF	RTCC
	CLRF	L_BYTE
	CLRF	H_BYTE
MLOOP	CALL	B16BCD
;---------DETECT SWITCH--------------------------------
READ_B  	BTFSS  	PORTB,SW ;CHECK IF ANY KEY PRESSED
	GOTO    	MLOOP	;NO, GOTO NEXT TASK
	MOVLW	25D	;
	CALL	DELAY	;YES, DELAY 20 MS AVOID BOUNCE
NOT_REL	BTFSC	PORTB,SW ;CHECK IF SWITCH RELEASED
	GOTO	NOT_REL	;NO, WAIT UNTIL RELEASE
	INCF      L_BYTE,F	;OKAY, INCREMENT COUNTER REG.
	BTFSC	STATUS,Z
	INCF	H_BYTE,F
	GOTO    	MLOOP  
CONVERT
	ADDWF	PCL,F	;{֥[ + WF
	RETLW	03FH	;0 r
	RETLW	006H	;1 r
	RETLW	05BH	;2 r
	RETLW	04FH	;3 r
	RETLW	066H	;4 r
	RETLW	06DH	;5 r
	RETLW	07DH	;6 r
	RETLW	007H	;7 r
	RETLW	07FH	;8 r
	RETLW	06FH	;9 r
	RETLW	077H	;A r
	RETLW	07CH	;B r
	RETLW	039H	;C r
	RETLW	05EH	;D r
	RETLW	079H	;E r
	RETLW	071H	;F r

B16BCD
	MOVLW	00100000B	;DISABLE RTCC INTERRUPT
	MOVWF	INTCON
	BCF	STATUS,C	;clear the carry bit
	MOVLW	16D
	MOVWF	LPCNT
	CLRF	R0
	CLRF	R1
	CLRF	R2
LOOP16	RLF	L_BYTE,F
	RLF	H_BYTE,F
	RLF	R2,F
	RLF	R1,F
	RLF	R0,F
	DECFSZ	LPCNT,F
	GOTO	ADJDEC
;----------CONVERT R0,R1 TO 4 7SEGMENT
	MOVF	R0,W
	MOVWF	TEMP
	ANDLW	0FH
	CALL	CONVERT
	MOVWF	BUFFER
	SWAPF	TEMP,W
	ANDLW	0FH
	CALL	CONVERT
	MOVWF	BUFFER+1
	MOVF	R1,W
	MOVWF	TEMP
	ANDLW	0FH
	CALL	CONVERT
	MOVWF	BUFFER+2
	SWAPF	TEMP,W
	ANDLW	0FH
	CALL	CONVERT
	MOVWF	BUFFER+3
	MOVLW	10100000B	;ENABLE RTCC INTERRUPT
	MOVWF	INTCON
	RETURN
ADJDEC	MOVLW	R2
	MOVWF	FSR
	CALL	ADJBCD
	MOVLW	R1
	MOVWF	FSR
	CALL	ADJBCD
	MOVLW	R0
	MOVWF	FSR
	CALL	ADJBCD
	GOTO	LOOP16
ADJBCD	MOVLW	3
	ADDWF	IND,W
	MOVWF	TEMP
	BTFSC	TEMP,3		; test if result > 7
	MOVWF	IND
	MOVLW	30H
	ADDWF	IND,W
	MOVWF	TEMP
	BTFSC	TEMP,7          ; test if result > 7
	MOVWF	IND               ; save as MSD
	RETURN
	
SERLOUT	MOVLW	8	;H`{
	MOVWF	BITCNT	;b`e,NƦsJBIT_CNT
LOOP8	BCF	PORTB,DAT	;`}l,ڭ̥]Ĥ@O0
	RRF   	TEMP,F	;NTEMPk,Ĥ@l,Ci
	BTFSC	STATUS,C	;STATUS,C;p0hUyO
	BSF	PORTB,DAT	;N74LS164,DATm1;QpWy0
	BSF	PORTB,CLK	;DATǳƧ,eXɯ߰T
	BCF	PORTB,CLK	;ɯߨuOON,OFF
	DECFSZ	BITCNT,F	;BIT_CNT=BIT_CNT-1,p0Uy
	GOTO	LOOP8	;hLOOP8,`8짹
	RETURN

DELAY			;HU@ʿu@{,تO
	MOVWF	0DH	;sJΤHμȦs f0D
DLY1	MOVLW	0FFH	;s ffh Jwfu@
	MOVWF	0EH	;sJΤHμȦs f0E
DLY2	DECFSZ	0EH	;0E = 0E - 1,psLUy
	GOTO	DLY2	;h DLY2 (soyQL)
	DECFSZ	0DH	;0f = 0f - 1,psLUy
	GOTO	DLY1	;h DLY1 (soyQL)
	RETURN		;ʿ{즹
	END
